
Serial port;
import processing.serial.*; // import the library
import processing.net.*;
Client client;

float x, y;
float x_, y_;
float posX, posY;
float posX1, posY1;
float dx, dy;
float rc1, rc2;
float rotate;
color color1;
boolean reset;
float rotationSpeed;
float check;
boolean border1;
float rotationSun;
boolean active;
int speed;
String[] lines;
float [] angle;
String[] rules;
float [] resetTime;
int g;
String dayChar;
int dayInt;
float updateValue;
float oldUpdateValue;
boolean nextDayLoading;
float scalingNight;
float waitingTime;
int night;
float currentTime;
float startingTime;
float timeDifference;
float waiter;
float dValue;
int f;
color buttonColor = 255;
int transp = 230;
color buttonColor2 = 255;
int transp2 = 230;

int rotatingState= 0;

//nieuwe code
Control control;
Sensors sensors;
DigitalClock digitalClock;
Button button;

PFont myFont;
int a;
int b;
int c;
int d;
int timerSpender;

void setup() {
  client = new Client(this, "130.89.91.63", 8080);
  myFont = loadFont("Didot-Italic-48.vlw");
  textFont(myFont, 35);

  control = new Control();
  sensors = new Sensors();
  digitalClock = new DigitalClock(40, 20, height+10);
  button = new Button();

  control = new Control();
  println("Available serial ports:");
  for (int i = 0; i<Serial.list ().length; i++) { 
    print("[" + i + "] ");
    println(Serial.list()[i]);
  }

  size(600, 800);
  rectMode(CENTER);
  // port = new Serial(this, Serial.list()[9], 9600);
  //DataBase position sun
  dayInt = 1;
  for (int i = 1; i<dayInt+1; i++) {
    dayChar = str(dayInt);
    lines = loadStrings("Sun" + dayChar + "Jan.txt");
  }
  rules = loadStrings("waitingTime.txt");
  night = 0;
  x = width/2;
  y = width/2;
  g = 0;
  rotationSun = PI/50;
  rotate = HALF_PI;
  active = false;
  x_ = cos(rotationSun)*200+300;
  y_ = sin(rotationSun)*200+300;
  color1 = color(255, 255, 255);
  rotationSpeed = 0;
  reset = false;
  frameRate(200);
  check = rc1/rc2;
  border1 = false;
  speed = 1;
  nextDayLoading = false;
  f = 5*1000;
  waitingTime = f;  //real waitingTime should be 900000
  scalingNight = 2*1000;  //real factor should be 3600000

  currentTime = 0;
  startingTime = 0;
  timeDifference = 0;
  oldUpdateValue = 180;
  //Creatin floats to declare and get the values out of the string
  angle  = new float[lines.length];
  for (int i = 0; i<lines.length; i++) {
    angle[i] = float(trim(lines[i]));
  }

  resetTime  = new float[rules.length];
  for (int i = 0; i<rules.length; i++) {
    resetTime[i] = float(trim(rules[i]));
  }
}

void draw() {
  display();
  update();
  restart();
  button.display();
  button.update();

  pushMatrix();
  translate(0, -30);
  control.display();
  sensors.display(control.b, control.d, control.a, control.c);
  digitalClock.getTime();
  digitalClock.display();
  popMatrix();
}

void display() {
  pushMatrix();
  translate(0, 200);
  background(0);
  fill(150);
  //base
  ellipse(x, y, 210, 210);
  fill(255);
  ellipse(x, y, 200, 200);
  //sun
  fill(255, 255, 0);
  ellipse(x_, y_, 40, 40);
  fill(100);
  pushMatrix();
  translate(x, y);
  rotate(rotate);
  fill(200);
  //vertical garden
  fill(#935D0C);
  quad(30, -95, -30, -95, -70, -10, 70, -10);
  stroke(255);
  fill(160);
  noStroke();
  quad(-50, -20, -30, -20, -25, -45, -40, -45);
  quad(50, -20, 30, -20, 25, -45, 40, -45);
  quad(10, -20, -10, -20, -8, -45, 8, -45);
  fill(255, 0, 0);
  ellipse(-35, -35, 12, 10);
  fill(0, 200, 0);
  ellipse(-35, -30, 6, 5);
  stroke(255);
  //detecting lines
  line(30, -95, 30, -250);
  line(-30, -95, -30, -250);
  stroke(color1);
  line(0, -95, 0, -250);
  stroke(0);
  popMatrix();
  for (float i = 0; i<2*PI; i+=PI/8) {
    pushMatrix();
    translate(x_, y_);
    rotate(i);
    stroke(255, 255, 0);
    line(30, 0, 50, 0);
    noStroke();
    popMatrix();
  }
  popMatrix();
}

void update() {

  //Mapping the rotationfactor from radions into degrees 
  updateValue = map(rotate, 0.5*PI+PI/50, 1.5*PI, 180, 0);

  //sending the angle to arduino
  //if (millis()>waiter) {
  //waiter = millis();
  dValue =  oldUpdateValue-updateValue;
  oldUpdateValue = updateValue;
  //port.write((dValue));
  //}
  //port.write((dValue));
  // if (port.available()>0) {
  //print((char)port.read());
  // }
  currentTime = millis();
  timeDifference = currentTime - startingTime;
  if (dValue>0) {
    rotatingState = 1;
  }

  if (dValue == 0) {
    rotatingState = 0;
  }

  if (dValue<0) {
    rotatingState = -1;
  }

  //port.write((int)(rotatingState));
  //println("rotatingState="+rotatingState);
  ////println("dValue=" +dValue);
  client.write(rotatingState); 
  println(rotatingState);


  //Starting position5
  posX = sin(rotate);
  posY = cos(rotate);
  //Position outsidecircle of the model 
  posX1 = sin(rotate)*90+300;
  posY1 = -cos(rotate)*90+300;
  //position of the sun
  x_ = cos(rotationSun)*200+300;
  y_ = sin(rotationSun)*200+300;
  //line difference
  dx = posX1-x_;
  dy = y_-posY1;
  //coefficient of the non-visble lines between sun and SG, and a penduticular line on SG
  rc1 = posY/posX;
  rc2 = dy/dx;
  check = rc1/rc2;

  //importing rotation from textfile, changing to radians
  rotationSun = (angle[g]/360)*2*PI-HALF_PI;
  //Correction if the position is on the x-axis
  if (angle[g] >= 177.5 && angle[g]<=182.5) {
    g++;
    //waitingTime*=2;
  }

  //checking if the position of the garden regarding to the position of the sun is correct
  if (active) {
    if (x_>=300 && rotate>=0 && rotate<=PI) {
      if ( check>0.99 && check<1.01) {
        color1 = color(0, 255, 0);
        reset = true;
        g++;
        waitingTime = f;
        rotationSpeed = 0;
        startingTime = millis();
      }
    } else if (x_<300 && rotate<=2*PI && rotate>=PI) {
      if ( check>0.99 && check<1.01) {
        color1 = color(0, 255, 0);
        reset = true;
        g++;
        rotationSpeed = 0;
        startingTime = millis();
      }
    }
  }

  if (check != 1) {
    if (nextDayLoading&&border1) {
      rotate-=rotationSpeed*speed;
    }
    if (!border1 && !nextDayLoading) {
      rotate += rotationSpeed*speed;
    }
    if (rotate<.5*PI+PI/50) {
      border1 = false;
    }
  }
}

void restart() {
  if (reset && timeDifference > (waitingTime)/speed) {
    reset = false;
    rotationSpeed = PI/7000;
    color1 = color(255);
  }

  if (nextDayLoading) {
    if (timeDifference >= resetTime[dayInt-1] * scalingNight) {
      nextDayLoading = false;
      active = true;
    }
  }

  if (g >= angle.length) {
    nextDayLoading = true;
    border1 = true;
    active = false;
    //load the new date information
    dayInt++;
    for (int i = 1; i<dayInt+1; i++) {
      dayChar = str(dayInt);
      lines = loadStrings("Sun" + dayChar + "Jan.txt");
    }
    angle  = new float[lines.length];
    for (int i = 0; i<lines.length; i++) {
      angle[i] = float(trim(lines[i]));
    } 
    g = 0;
  }
}
