// total sketch for module 2 project
// made by Froukje Temme
// 13 January 2020




#include <Servo.h>
#define pump 5
#include "dht.h"
#define dht_apin A0 // Analog Pin sensor is connected to

Servo myservo;  // create servo object to control a servo

int potpin = 0;  // analog pin used to connect the potentiometer
unsigned int val = 0;   // variable to read the value from the analog pin
int waiter;
int sensorPin = A1; // reading data from A0 pin of ADC
float sensorValue = 0;
int timer1;
int timer2;
dht DHT;
int pumpstate;
int checkvalue;

void setup()
{
  Serial.begin(9600);
  myservo.attach(9);  // attaches the servo on pin 9 to the servo object
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(pump, OUTPUT);
  timer1 = 0;
  pumpstate = 0; // 0 means out
  checkvalue = 1000;
}

void loop()
{
  if (Serial.available() > 0) { // reads the value of the potentiometer (value between 0 and 1023)
    val = Serial.read();
    if (val == 1) {
      digitalWrite(2, LOW);
      digitalWrite(3, HIGH);
      analogWrite(11, 255);
    } else if (val == 0) {
      digitalWrite(2, LOW);
      digitalWrite(3, LOW);
      analogWrite(11, 0);
    } else if (val == -1) {
      digitalWrite(2, HIGH);
      digitalWrite(3, LOW);
      analogWrite(11, 255);
    }
  }

  // code for the humidity sensor in the ground
  for (int i = 0; i <= 100; i++) {
    sensorValue += analogRead(sensorPin);
  }
  sensorValue = sensorValue / 100.0;

  // code for temperature and humidity sensor
  DHT.read11(dht_apin);
  if (millis() > timer1 + checkvalue) {
    timer1 = millis();

    // send data
    Serial.print("A");
    Serial.println(pumpstate);
    Serial.print("B");
    Serial.println((int)sensorValue);
    Serial.print("C");
    Serial.println((int)DHT.humidity);
    Serial.print("D");
    Serial.println((int)DHT.temperature);

  }


  //    if (pumpstate == 0) { //if pumpstate is off
  //      analogWrite(pump, 255); // put it on
  //      pumpstate = 1; // put the state on on)
  //    } else {
  //      analogWrite(pump, 0); // put it off
  //      pumpstate = 0;
  //    }
  //  }

  // The pump will be turned on if the soil value is too dry
  if (sensorValue > 700) { // when the value of the soil is too low, there will be water
    if (millis() > timer2 + 5000) {
      timer2 = millis();
      if (pumpstate == 0) { //if pumpstate is off
        analogWrite(pump, 255); // put it on
        pumpstate = 1; // put the state on on)
      } else {
        analogWrite(pump, 0); // put it off
        pumpstate = 0;
      }
    }

    if ((int)DHT.humidity >= 60 && ((int)DHT.temperature >= 28)) {
      checkvalue = 400;
    } else if ((int)DHT.humidity >= 60 || (int)DHT.temperature >= 28 ) {
      checkvalue = 600;
    } else {
      checkvalue = 1000;
    }
  }
}
